package client

import (
	"net/http"
	"net/url"
	"time"

	cuc "git.loafle.net/commons_go/util/context"
)

type SocketHandler interface {
	SocketContext(parent cuc.Context) SocketContext

	GetURL() *url.URL
	GetRequestHeader() http.Header

	GetMaxMessageSize() int64
	GetWriteTimeout() time.Duration
	GetReadTimeout() time.Duration
	GetPongTimeout() time.Duration
	GetPingTimeout() time.Duration
	GetPingPeriod() time.Duration

	// Validate is check handler value
	// If you override ths method, must call
	//
	// func (sh *SocketHandlers) Validate() {
	// 	sh.SocketHandlers.Validate()
	//  ...
	// }
	Validate()
}
